Index: main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkThemesDialog.i18n.js
===================================================================
--- main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkThemesDialog.i18n.js	(revision 29041)
+++ main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkThemesDialog.i18n.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -71,7 +71,8 @@
 {
     var mapping = Ext.data.Record.create([
         {name: 'id', mapping: '@id'},
-        {name: 'label', mapping: '@label'}
+        {name: 'label', mapping: '@label'},
+        {name: 'name', mapping: '@name'}
     ]);
     
     var proxy = new Ext.data.HttpProxy({
@@ -105,7 +106,12 @@
     {
         columns.push(checkModel);
     }
-    columns.push({header: "<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_THEME_COLUMN_NAME"/>", width: 300, menuDisabled: true, sortable: true, dataIndex: 'label'});
+    
+    // Labels
+    columns.push({header: "<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_THEME_COLUMN_NAME"/>", width: 160, menuDisabled: true, sortable: true, dataIndex: 'label'});
+    
+    // Names
+    columns.push({header: "<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_THEME_ID_COLUMN_NAME"/>", width: 159, menuDisabled: true, sortable: true, dataIndex: 'name'});
     
     var sm;
     if (this._selectable)
@@ -120,7 +126,6 @@
     var listView = new org.ametys.ListView({
         region: 'center',
         store: this._store,
-        hideHeaders: true,
         cm: new Ext.grid.ColumnModel({
             defaults: {
                 width: 20,
@@ -222,7 +227,8 @@
     {
         themes.push({
             id: selectedThemes[i].data.id,
-            label: selectedThemes[i].data.label
+            label: selectedThemes[i].data.label,
+            name: selectedThemes[i].data.name
         });
     }
     
@@ -245,10 +251,20 @@
 
 org.ametys.linkdirectory.LinkThemesDialog.prototype._selectOnLoad = function(records, options, success)
 {
-    if (success)
-    {
-        this.setSelected(options.values);
-    }
+	
+	if (success)
+	{
+		// Select the last added entry
+	    if (options.ignoreSelectable)
+		{
+			this._list.getSelectionModel().selectRow(this._store.indexOfId(options.values[0]));
+			return;
+		}
+	    else
+	    {
+	        this.setSelected(options.values);
+	    }
+	}
 }
 
 org.ametys.linkdirectory.LinkThemesDialog.prototype._onSelect = function(sm)
@@ -273,7 +289,18 @@
         fn: function(btn, text, opts) {
             if (btn == 'ok')
             {
-                this._doAddTheme(text);
+	            if (text === null || text === "")
+            	{
+		            Ext.Msg.show({
+		                title: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_EMPTY_THEME_TITLE'/>",
+		                msg: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_EMPTY_THEME_MSG'/>",
+		                buttons: Ext.Msg.OK,
+		                icon: Ext.MessageBox.ERROR
+		            });
+		            return;
+            	}
+	            
+	            this._doAddTheme(text);
             }
         },
         scope: this
@@ -299,7 +326,8 @@
         return;
     }
     
-    var error = response.selectSingleNode('ActionResult/error')[org.ametys.servercomm.ServerComm.xmlTextContent];
+    var error = response.selectSingleNode('ActionResult/error')[org.ametys.servercomm.ServerComm.xmlTextContent],
+        id = response.selectSingleNode('ActionResult/id')[org.ametys.servercomm.ServerComm.xmlTextContent];
     
     if (error == 'theme-already-exists')
     {
@@ -312,7 +340,14 @@
         return;
     }
     
-    this._store.load();
+    var opts = {};
+    
+    opts.callback = this._selectOnLoad;
+    opts.scope = this;
+    opts.values =  [id];
+    opts.ignoreSelectable = true;
+    
+    this._store.load(opts);
 }
 
 org.ametys.linkdirectory.LinkThemesDialog.prototype._editTheme = function()
@@ -346,6 +381,17 @@
 
 org.ametys.linkdirectory.LinkThemesDialog.prototype._doEditTheme = function(id, text)
 {
+	if (text === null || text === "")
+	{
+        Ext.Msg.show({
+            title: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_EMPTY_THEME_TITLE'/>",
+            msg: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_EMPTY_THEME_MSG'/>",
+            buttons: Ext.Msg.OK,
+            icon: Ext.MessageBox.ERROR
+        });
+        return;
+	}
+	
     var params = {
         id: id,
         label: text,
@@ -369,7 +415,7 @@
     if (error == 'theme-already-exists')
     {
         Ext.Msg.show({
-            title: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_THEME_EDIT_TITLE'/>",
+            title: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_EMPTY_THEME_TITLE'/>",
             msg: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_THEME_ERROR_ALREADY_EXISTS'/>",
             buttons: Ext.Msg.OK,
             icon: Ext.MessageBox.ERROR
@@ -378,6 +424,8 @@
     }
     
     this._store.load();
+    
+    this._fireMessages(response);
 }
 
 org.ametys.linkdirectory.LinkThemesDialog.prototype._removeThemes = function()
@@ -432,7 +480,15 @@
     
     this._store.load();
     
-    // Fire messages
+    this._fireMessages(response);
+}
+
+/**
+ * Fire the metadata changed messages from the server's response
+ */
+org.ametys.linkdirectory.LinkThemesDialog.prototype._fireMessages = function(response)
+{
+	// Fire messages
     var modifiedLinks = response.selectSingleNode('ActionResult/modified-links')[org.ametys.servercomm.ServerComm.xmlTextContent];
     if (modifiedLinks != '')
     {
Index: main/plugin-link-directory/resources/js/org/ametys/linkdirectory/MoveLinkButton.js
===================================================================
--- main/plugin-link-directory/resources/js/org/ametys/linkdirectory/MoveLinkButton.js	(revision 0)
+++ main/plugin-link-directory/resources/js/org/ametys/linkdirectory/MoveLinkButton.js	(revision 0)
@@ -0,0 +1,62 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.linkdirectory');
+
+/**
+ * Enable or disable link reordering buttons depending on the link position.
+ */
+org.ametys.linkdirectory.MoveLinkButton = function(id, configuration, pluginName)
+{
+	org.ametys.linkdirectory.MoveLinkButton.superclass.constructor.call(this, id, configuration, pluginName);
+}
+
+Ext.extend(org.ametys.linkdirectory.MoveLinkButton, org.ametys.ribbon.control.button.ActionSelectionButton, {});
+
+org.ametys.linkdirectory.MoveLinkButton.prototype.onMessage = function(messages)
+{
+    for (var i = messages.length-1; i >= 0; i--)
+    {
+        if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
+        {
+            var allTargets = messages[i].getTargets();
+            var targets = org.ametys.messagebus.message.MessageTargetHelper.findAll(allTargets, this._testTarget.createDelegate(this));
+            
+            if (targets.length == 1 && this._testLink(targets[0]))
+            {
+                this.getElements().each(function(element) { element.enable(); });
+            }
+            else
+            {
+                this.getElements().each(function(element) { element.disable(); });
+            }
+        }
+    }
+}
+
+/**
+ * Test a link on a button.
+ * @return {org.ametys.messagebus.message.MessageTarget} The target to check
+ * @private
+ */
+org.ametys.linkdirectory.MoveLinkButton.prototype._testLink = function(target)
+{
+	var role = this.getConfiguration().role,
+        index = target.getParameters().index,
+        size= target.getParameters().size;
+        
+    return (((role == 'move-up' || role == 'move-first') && index != 0) || ((role == 'move-down' || role == 'move-last') && index != size - 1)) ? true : false;
+}
Index: main/plugin-link-directory/sitemap.xmap
===================================================================
--- main/plugin-link-directory/sitemap.xmap	(revision 28682)
+++ main/plugin-link-directory/sitemap.xmap	(working copy)
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!--
-   Copyright 2012 Anyware Services
+   Copyright 2015 Anyware Services
 
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
@@ -20,8 +20,6 @@
         <map:generators>
             <map:generator name="link" src="org.ametys.plugins.linkdirectory.link.LinkGenerator" logger="org.ametys.plugins.linkdirectory.link.LinkGenerator"/>
             <map:generator name="link-list" src="org.ametys.plugins.linkdirectory.link.LinkListGenerator" logger="org.ametys.plugins.linkdirectory.link.LinkListGenerator"/>
-            
-            <map:generator name="theme" src="org.ametys.plugins.linkdirectory.theme.ThemeGenerator" logger="org.ametys.plugins.linkdirectory.theme.ThemeGenerator"/>
             <map:generator name="theme-list" src="org.ametys.plugins.linkdirectory.theme.ThemeListGenerator" logger="org.ametys.plugins.linkdirectory.theme.ThemeListGenerator"/>
         </map:generators>
         
@@ -31,10 +29,13 @@
             <map:action name="create-link" src="org.ametys.plugins.linkdirectory.link.CreateLinkAction" logger="org.ametys.plugins.linkdirectory.link.CreateLinkAction"/>
             <map:action name="update-link" src="org.ametys.plugins.linkdirectory.link.UpdateLinkAction" logger="org.ametys.plugins.linkdirectory.link.UpdateLinkAction"/>
             <map:action name="delete-link" src="org.ametys.plugins.linkdirectory.link.DeleteLinkAction" logger="org.ametys.plugins.linkdirectory.link.DeleteLinkAction"/>
-
+            <map:action name="move-link"   src="org.ametys.plugins.linkdirectory.link.MoveLinkAction"   logger="org.ametys.plugins.linkdirectory.link.MoveLinkAction"/>
+            
             <map:action name="create-theme" src="org.ametys.plugins.linkdirectory.theme.CreateThemeAction" logger="org.ametys.plugins.linkdirectory.theme.CreateThemeAction"/>
             <map:action name="update-theme" src="org.ametys.plugins.linkdirectory.theme.UpdateThemeAction" logger="org.ametys.plugins.linkdirectory.theme.UpdateThemeAction"/>
             <map:action name="delete-theme" src="org.ametys.plugins.linkdirectory.theme.DeleteThemeAction" logger="org.ametys.plugins.linkdirectory.theme.DeleteThemeAction"/>
+            
+            <map:action name="set-userprefs" src="org.ametys.plugins.linkdirectory.LinkDirectorySetUserPreferencesAction" logger="org.ametys.plugins.linkdirectory.LinkDirectorySetUserPreferencesAction"/>
         </map:actions>
     </map:components>
 
@@ -64,6 +65,18 @@
                 <map:serialize type="xhtml"/>
             </map:match>
             
+            <!-- Service's user preferences -->
+            <map:match pattern="set-user-preferences">
+			    <map:act type="set-userprefs">
+			        <map:generate type="action-result" label="xml"/>
+			        <map:transform type="i18n">
+	                    <map:parameter name="locale" value="{request-attr:renderingLanguage}"/>
+	                    <map:parameter name="plugin" value="{request-attr:pluginName}"/>
+			        </map:transform>
+	                <map:serialize type="xml"/>
+			    </map:act>
+			</map:match>
+            
             <map:match pattern="**">
                 <map:act type="check-not-front"/>
             </map:match>
@@ -103,10 +116,18 @@
                 </map:act>
             </map:match>
             
-            <!-- Themes -->
-            <map:match pattern="theme.xml">
-                <map:generate type="theme"/>
-                <map:serialize type="xml"/>
+            <map:match pattern="link/move">
+                <map:act type="move-link">
+                    <map:parameter name="siteName" value="{parent-context-attr:siteName}"/>
+                    <map:parameter name="id" value="{parent-context-attr:id}"/>
+                    <map:parameter name="previousSiblingId" value="{parent-context-attr:previousSiblingId}"/>
+                    <map:parameter name="nextSiblingId" value="{parent-context-attr:nextSiblingId}"/>
+                    <map:parameter name="role" value="{parent-context-attr:role}"/>
+                    <map:generate type="action-result">
+                        <map:parameter name="msg" value="{msg}"/>
+                    </map:generate>
+                    <map:serialize type="xml"/> 
+                </map:act>
             </map:match>
             
             <map:match pattern="theme/create">
@@ -124,6 +145,7 @@
                     <map:generate type="action-result">
                         <map:parameter name="id" value="{id}"/>
                         <map:parameter name="error" value="{error}"/>
+                        <map:parameter name="modified-links" value="{modified-links}"/>
                     </map:generate>
                     <map:serialize type="xml"/>
                 </map:act>
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/DirectoryHelper.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/DirectoryHelper.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/DirectoryHelper.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -15,30 +15,121 @@
  */
 package org.ametys.plugins.linkdirectory;
 
+import java.text.Normalizer;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.context.Context;
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
+import org.apache.avalon.framework.logger.LogEnabled;
+import org.apache.avalon.framework.logger.Logger;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
+import org.apache.cocoon.components.ContextHelper;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.collections.IteratorUtils;
+import org.apache.commons.lang.ArrayUtils;
 import org.apache.commons.lang.StringUtils;
+import org.xml.sax.ContentHandler;
+import org.xml.sax.SAXException;
 
+import org.ametys.plugins.explorer.resources.Resource;
+import org.ametys.plugins.linkdirectory.repository.DefaultLink;
 import org.ametys.plugins.linkdirectory.repository.DefaultLinkFactory;
+import org.ametys.plugins.linkdirectory.repository.DefaultTheme;
 import org.ametys.plugins.linkdirectory.repository.DefaultThemeFactory;
+import org.ametys.plugins.linkdirectory.theme.ThemeExpression;
+import org.ametys.plugins.repository.AmetysObject;
+import org.ametys.plugins.repository.AmetysObjectIterable;
+import org.ametys.plugins.repository.AmetysObjectResolver;
 import org.ametys.plugins.repository.AmetysRepositoryException;
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
+import org.ametys.plugins.repository.TraversableAmetysObject;
+import org.ametys.plugins.repository.UnknownAmetysObjectException;
+import org.ametys.plugins.repository.metadata.BinaryMetadata;
 import org.ametys.plugins.repository.query.expression.Expression;
+import org.ametys.plugins.repository.query.expression.OrExpression;
+import org.ametys.runtime.group.GroupsManager;
+import org.ametys.runtime.plugins.core.userpref.UserPreferencesException;
+import org.ametys.runtime.plugins.core.userpref.UserPreferencesManager;
+import org.ametys.runtime.user.User;
+import org.ametys.runtime.user.UsersManager;
+import org.ametys.runtime.util.I18nUtils;
+import org.ametys.runtime.util.I18nizableText;
+import org.ametys.web.WebConstants;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
+import org.ametys.web.repository.page.Page;
 import org.ametys.web.repository.site.Site;
+import org.ametys.web.repository.site.SiteManager;
+import org.ametys.web.userpref.FOUserPreferencesConstants;
 
 /**
  * Link directory helper.
  */
-public final class DirectoryHelper
+public final class DirectoryHelper implements Component, Contextualizable, LogEnabled, Serviceable
 {
-    
     private static final String __PLUGIN_NODE_NAME = "linkdirectory";
     
     private static final String __LINKS_NODE_NAME = "ametys:directoryLinks";
     
     private static final String __THEMES_NODE_NAME = "ametys:themes";
     
-    private DirectoryHelper()
+    /** The logger */
+    private static Logger _logger;
+    
+    /** The Ametys object resolver */
+    private static AmetysObjectResolver _ametysObjectResolver;
+    
+    /** The users manager */
+    private static UsersManager _usersManager;
+
+    /** The groups manager */
+    private static GroupsManager _groupsManager;
+    
+    /** The site manager */
+    private static SiteManager _siteManager;
+    
+    /** I18nUtils */
+    private static I18nUtils _i18nUtils;
+    
+    /** The rendering context handler */
+    private static RenderingContextHandler _renderingContextHandler;
+    
+    /** The user preferences manager */
+    private static UserPreferencesManager _userPreferencesManager;
+    
+    /** The Avalon context */
+    private static Context _context;
+    
+    
+    public void contextualize(Context context) throws ContextException
     {
-        // Hides the default constructor.
+        _context = context;
+    }
+    
+    public void enableLogging(Logger logger)
+    {
+        _logger = logger;
+    }
+    
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        _ametysObjectResolver = (AmetysObjectResolver) manager.lookup(AmetysObjectResolver.ROLE);
+        _usersManager = (UsersManager) manager.lookup(UsersManager.ROLE + ".FO");
+        _groupsManager = (GroupsManager) manager.lookup(GroupsManager.ROLE + ".FO");
+        _i18nUtils = (I18nUtils) manager.lookup(I18nUtils.ROLE);
+        _renderingContextHandler = (RenderingContextHandler) manager.lookup(RenderingContextHandler.ROLE);
+        _siteManager = (SiteManager) manager.lookup(SiteManager.ROLE);
+        _userPreferencesManager = (UserPreferencesManager) manager.lookup(UserPreferencesManager.ROLE + ".FO");
     }
     
     /**
@@ -62,10 +153,10 @@
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get the links root node.
      * @param site the site
      * @param language the language.
-     * @return the word definitions storage node.
+     * @return the links root node.
      * @throws AmetysRepositoryException if a repository error occurs.
      */
     public static ModifiableTraversableAmetysObject getLinksNode(Site site, String language) throws AmetysRepositoryException
@@ -83,15 +174,15 @@
         }
         catch (AmetysRepositoryException e)
         {
-            throw new AmetysRepositoryException("Error getting the word definitions node for site " + site.getName() + " and language " + language, e);
+            throw new AmetysRepositoryException("Error getting the link directory root node for site " + site.getName() + " and language " + language, e);
         }
     }
 
     /**
-     * Get the word definitions storage node.
+     * Get the themes storage node.
      * @param site the site
      * @param language the language.
-     * @return the word definitions storage node.
+     * @return the themes storage node.
      * @throws AmetysRepositoryException if a repository error occurs.
      */
     public static ModifiableTraversableAmetysObject getThemesNode(Site site, String language) throws AmetysRepositoryException
@@ -114,9 +205,9 @@
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get the plugin node path
      * @param siteName the site name.
-     * @return the word definitions storage node.
+     * @return the plugin node path.
      */
     public static String getPluginNodePath(String siteName)
     {
@@ -124,10 +215,10 @@
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get the links root node path
      * @param siteName the site name.
-     * @param language the language.
-     * @return the word definitions storage node.
+     * @param language the language
+     * @return the links root node path.
      */
     public static String getLinksNodePath(String siteName, String language)
     {
@@ -135,10 +226,10 @@
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get the themes node path
      * @param siteName the site name.
-     * @param language the language.
-     * @return the word definitions storage node.
+     * @param language the language
+     * @return the themes node path.
      */
     public static String getThemesNodePath(String siteName, String language)
     {
@@ -146,19 +237,42 @@
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get all the links
+     * @param siteName the site name.
+     * @param language the language.
+     * @return all the links' nodes
+     */
+    public static String getAllLinksQuery(String siteName, String language)
+    {
+        return getLinksNodePath(siteName, language) + "/element(*, " + DefaultLinkFactory.LINK_NODE_TYPE + ")";
+    }
+    
+    /**
+     * Get the link query corresponding to the expression passed as a parameter
      * @param siteName the site name.
      * @param language the language.
      * @param expression 
-     * @return the word definitions storage node.
+     * @return the link corresponding to the expression passed as a parameter
+     */
+    public static String getLinksQuery(String siteName, String language, Expression expression)
+    {
+        return getLinksNodePath(siteName, language) + "/element(*, " + DefaultLinkFactory.LINK_NODE_TYPE + ")[" + expression.build() + "]";
+    }
+    
+    /**
+     * Get the theme query corresponding to the expression passed as a parameter
+     * @param siteName the site name.
+     * @param language the language.
+     * @param expression 
+     * @return the theme corresponding to the expression passed as a parameter
      */
-    public static String getLinkQuery(String siteName, String language, Expression expression)
+    public static String getThemeQuery(String siteName, String language, Expression expression)
     {
         return getLinksNodePath(siteName, language) + "/element(*, " + DefaultLinkFactory.LINK_NODE_TYPE + ")[" + expression.build() + "]";
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get the query verifying the existence of an url
      * @param siteName the site name.
      * @param language the language.
      * @param url the url to test. 
